From a3341c0ee9beae992a760f5fc77a631f7ac23647 Mon Sep 17 00:00:00 2001
From: Mark Reynolds <mreynolds@redhat.com>
Date: Wed, 14 Feb 2018 21:58:19 -0500
Subject: [PATCH] Ticket 49519 - Add more Cockpit UI content

Description:  Add recent updates to Cockpit UI

https://pagure.io/389-ds-base/issue/49519

Reviewed by: firstyear(Thanks!)
---
 src/cockpit/389-console/README.md                  |  16 +-
 src/cockpit/389-console/backend.html               | 236 +++++---
 src/cockpit/389-console/css/ds.css                 | 159 +++++-
 src/cockpit/389-console/css/tabs.css               |   1 +
 src/cockpit/389-console/index.html                 |  36 +-
 src/cockpit/389-console/js/backend.js              | 214 ++++++--
 src/cockpit/389-console/js/ds.js                   |  47 +-
 src/cockpit/389-console/js/replication.js          | 603 +++++++++++++++++++--
 src/cockpit/389-console/js/schema.js               | 329 ++++++++++-
 src/cockpit/389-console/replication.html           | 447 ++++++++++-----
 src/cockpit/389-console/schema.html                | 372 ++++++++++---
 src/cockpit/389-console/security.html              |   7 +-
 src/cockpit/389-console/servers.html               |   5 +-
 .../389-console/static/bootstrap-theme.min.css     |   6 +
 .../389-console/static/bootstrap-theme.min.css.map |   1 +
 src/cockpit/389-console/static/bootstrap.min.css   |   6 +
 .../389-console/static/bootstrap.min.css.map       |   1 +
 src/cockpit/389-console/static/bootstrap.min.js    |   7 +
 .../static/fonts/bootstrap-theme.min.css           |   6 +
 .../static/fonts/bootstrap-theme.min.css.map       |   1 +
 .../389-console/static/fonts/bootstrap.min.css     |   6 +
 .../389-console/static/fonts/bootstrap.min.css.map |   1 +
 .../static/fonts/glyphicons-halflings-regular.eot  | Bin 0 -> 20127 bytes
 .../static/fonts/glyphicons-halflings-regular.svg  | 288 ++++++++++
 .../static/fonts/glyphicons-halflings-regular.ttf  | Bin 0 -> 45404 bytes
 .../static/fonts/glyphicons-halflings-regular.woff | Bin 0 -> 23424 bytes
 .../fonts/glyphicons-halflings-regular.woff2       | Bin 0 -> 18028 bytes
 src/cockpit/389-console/static/jquery-3.3.1.min.js |   4 +
 src/cockpit/389-console/static/jquery-ui.min.js    |  14 +
 .../389-console/static/jquery.dropdown.min.css     |   2 +
 .../389-console/static/jquery.dropdown.min.js      |  10 +
 .../389-console/static/jquery.fileTree-1.01.zip    | Bin 0 -> 58353 bytes
 src/cockpit/389-console/static/jquery.min.js       |   6 +
 src/cockpit/389-console/static/npm.js              |  13 +
 34 files changed, 2390 insertions(+), 454 deletions(-)
 create mode 100644 src/cockpit/389-console/static/bootstrap-theme.min.css
 create mode 100644 src/cockpit/389-console/static/bootstrap-theme.min.css.map
 create mode 100644 src/cockpit/389-console/static/bootstrap.min.css
 create mode 100644 src/cockpit/389-console/static/bootstrap.min.css.map
 create mode 100644 src/cockpit/389-console/static/bootstrap.min.js
 create mode 100644 src/cockpit/389-console/static/fonts/bootstrap-theme.min.css
 create mode 100644 src/cockpit/389-console/static/fonts/bootstrap-theme.min.css.map
 create mode 100644 src/cockpit/389-console/static/fonts/bootstrap.min.css
 create mode 100644 src/cockpit/389-console/static/fonts/bootstrap.min.css.map
 create mode 100644 src/cockpit/389-console/static/fonts/glyphicons-halflings-regular.eot
 create mode 100644 src/cockpit/389-console/static/fonts/glyphicons-halflings-regular.svg
 create mode 100644 src/cockpit/389-console/static/fonts/glyphicons-halflings-regular.ttf
 create mode 100644 src/cockpit/389-console/static/fonts/glyphicons-halflings-regular.woff
 create mode 100644 src/cockpit/389-console/static/fonts/glyphicons-halflings-regular.woff2
 create mode 100644 src/cockpit/389-console/static/jquery-3.3.1.min.js
 create mode 100644 src/cockpit/389-console/static/jquery-ui.min.js
 create mode 100644 src/cockpit/389-console/static/jquery.dropdown.min.css
 create mode 100644 src/cockpit/389-console/static/jquery.dropdown.min.js
 create mode 100644 src/cockpit/389-console/static/jquery.fileTree-1.01.zip
 create mode 100644 src/cockpit/389-console/static/jquery.min.js
 create mode 100644 src/cockpit/389-console/static/npm.js

diff --git a/src/cockpit/389-console/js/backend.js b/src/cockpit/389-console/js/backend.js
index 00631a826..4f3296561 100644
--- a/src/cockpit/389-console/js/backend.js
+++ b/src/cockpit/389-console/js/backend.js
@@ -6,7 +6,7 @@ function customMenu (node) {
       "label": "Create Suffix",
       "icon": "glyphicon glyphicon-plus",
       "action": function (data) {
-        // TODO Create suffix
+        $("#add-suffix-form").css('display', 'block');
       }
     }
   };
@@ -16,31 +16,35 @@ function customMenu (node) {
       "label": "Delete DB Link",
       "icon": "glyphicon glyphicon-trash",
       "action": function (data) {
-        // TODO Delete db link
-       }
-     }
+        if (confirm("Are you sure you want to delete this Database Link?")){
+          // Delete db link
+        }
+      }
+    }
   };
 
   var suffix_items = {
-     'import': {
-          "label": "Initialize Suffix",
-          "icon": "glyphicon glyphicon-circle-arrow-right",
-         "action": function (data) {
-           // TODO Import suffix
-          }
-      },
+    'import': {
+      "label": "Initialize Suffix",
+       "icon": "glyphicon glyphicon-circle-arrow-right",
+       "action": function (data) {
+         $("#import-ldif-form").css('display', 'block');
+       }
+     },
       'export': {
           "label": "Export Suffix",
           "icon": "glyphicon glyphicon-circle-arrow-left",
          "action": function (data) {
-           // TODO Export suffix
+           $("#export-ldif-form").css('display', 'block');
           }
       },
       'reindex': {
           "label": "Reindex Suffix",
           "icon": "glyphicon glyphicon-wrench",
          "action": function (data) {
-           // TODO Reindex suffix
+           if (confirm("This will impact DB performance during the indexing.  Are you sure you want to reindex all attributes?")){
+             // TODO Reindex suffix
+           }
           }
       },
       "create_db_link": {
@@ -57,17 +61,22 @@ function customMenu (node) {
         "label": "Create Sub-Suffix",
         "icon": "glyphicon glyphicon-triangle-bottom",
         "action": function (data) {
-          // TODO reate suffix
-
+          var suffix_id = $(node).attr('id');
+          var parent_suffix = suffix_id.substring(suffix_id.indexOf('-')+1);
+          $("#parent-suffix").html('<b>Parent Suffix:</b>&nbsp;&nbsp;' + parent_suffix);
+          $("#add-subsuffix-dn").val(' ,' + parent_suffix);
+          $("#add-subsuffix-form").css('display', 'block');
          }
       },
       'delete_suffix': {
-          "label": "Delete Suffix",
-          "icon": "glyphicon glyphicon-remove",
+         "label": "Delete Suffix",
+         "icon": "glyphicon glyphicon-remove",
          "action": function (data) {
-           // TODO Delete suffix
-          }
-      }
+           if (confirm("Are you sure you want to delete suffix?")){
+             // TODO Delete suffix
+           }
+         }
+       }
    };
 
    if ( $(node).attr('id') == "root" ) {
@@ -242,6 +251,7 @@ $(document).ready( function() {
       $("#manual-cache-form").hide();
       $("#auto-cache-form").show();
       $("#nsslapd-dncachememsize").prop('disabled', true);
+      $("#nsslapd-dncachememsize").val('AUTOTUNED');
       $("#nsslapd-cachememsize").prop('disabled', true);
       $("#nsslapd-cachesize").prop('disabled', true);
     }
@@ -255,20 +265,35 @@ $(document).ready( function() {
     }
 
     $(".cache-role").on("change", function() {
+      var cache_role = $("input[name=cache-role]:checked").val();
+      if (cache_role == "manual-cache") {
+        $("#auto-cache-form").hide();
+        $("#manual-cache-form").show();
+      } else {
+        // auto cache
+        $("#manual-cache-form").hide();
+        $("#auto-cache-form").show();
+      }
+    });
+
+    $("#backend-config-save-btn").on("click", function () {
       var role = $("input[name=cache-role]:checked").val();
       if (role == "manual-cache") {
-         $("#auto-cache-form").hide();
-         $("#manual-cache-form").show();
-         $("#nsslapd-dncachememsize").prop('disabled', false);
-         $("#nsslapd-cachememsize").prop('disabled', false);
-         $("#nsslapd-cachesize").prop('disabled', false);
+        // TODO - need to get cache values and fields (overwrite AUTOTUNED)
+        $("#nsslapd-dncachememsize").prop('disabled', false);
+        $("#nsslapd-dncachememsize").val('')
+        $("#nsslapd-cachememsize").prop('disabled', false);
+        $("#nsslapd-cachememsize").val('');
+        $("#nsslapd-cachesize").prop('disabled', false);
+        $("#nsslapd-cachesize").val('');
       } else {
-          // auto cache
-         $("#manual-cache-form").hide();
-         $("#auto-cache-form").show();
-         $("#nsslapd-dncachememsize").prop('disabled', true);
-         $("#nsslapd-cachememsize").prop('disabled', true);
-         $("#nsslapd-cachesize").prop('disabled', true);
+        // auto cache
+        $("#nsslapd-dncachememsize").prop('disabled', true);
+        $("#nsslapd-dncachememsize").val('AUTOTUNED');
+        $("#nsslapd-cachememsize").prop('disabled', true);
+        $("#nsslapd-cachememsize").val('AUTOTUNED');
+        $("#nsslapd-cachesize").prop('disabled', true);
+        $("#nsslapd-cachesize").val('AUTOTUNED');
       }
     });
 
@@ -341,8 +366,29 @@ $(document).ready( function() {
     })
     $("#chaining-oid-save").on("click", function() {
       // Update oids
+      var chaining_oids = $("#avail-chaining-oid-list").val();
+      for (var i = 0; chaining_oids && i < chaining_oids.length; i++) {
+        $('#chaining-oid-list').append($('<option/>', { 
+          value: chaining_oids[i],
+          text : chaining_oids[i] 
+        }));
+        $("#avail-chaining-oid-list option[value='" + chaining_oids[i] + "']").remove();
+      }
+      sort_list( $("#chaining-oid-list") );
       $("#chaining-oids-form").css('display', 'none');
     });
+    $("#delete-chaining-oid-button").on("click", function() {
+      var oids = $("#chaining-oid-list").find('option:selected');
+      if (oids && oids != '' && oids.length > 0) {
+        for (var i = 0; i < oids.length; i++) {
+          if ( $('#avail-chaining-comp-list option[value="' + oids[i].text + '"]').val() === undefined) {
+            $('#avail-chaining-oid-list').append($("<option/>").val(oids[i].text).text(oids[i].text));
+          }
+        }
+      }
+      $("#chaining-oid-list").find('option:selected').remove();
+      sort_list( $('#avail-chaining-oid-list') );
+    });
 
     // Chaining Comps
     $("#chain-comp-close").on("click", function() {
@@ -355,8 +401,29 @@ $(document).ready( function() {
       // Update Comps
       $("#chaining-comp-form").css('display', 'block');
     })
+    $("#delete-chaining-comp-button").on("click", function() {
+      var comps = $("#chaining-comp-list").find('option:selected');
+      if (comps && comps != '' && comps.length > 0) {
+        for (var i = 0; i < comps.length; i++) {
+          if ( $('#avail-chaining-comp-list option[value="' + comps[i].text + '"]').val() === undefined) {
+            $('#avail-chaining-comp-list').append($("<option/>").val(comps[i].text).text(comps[i].text));
+          }
+        }
+      }
+      $("#chaining-comp-list").find('option:selected').remove();
+      sort_list($('#avail-chaining-comp-list') );
+    });
     $("#chaining-comp-save").on("click", function() {
-      // Update comps
+      // Update comps      
+      var chaining_comps = $("#avail-chaining-comp-list").val();
+      for (var i = 0; chaining_comps && i < chaining_comps.length; i++) {
+        $('#chaining-comp-list').append($('<option/>', { 
+          value: chaining_comps[i],
+          text : chaining_comps[i] 
+        }));
+        $("#avail-chaining-comp-list option[value='" + chaining_comps[i] + "']").remove();
+      }
+      sort_list( $("#chaining-comp-list") );
       $("#chaining-comp-form").css('display', 'none');
     });
 
@@ -372,6 +439,89 @@ $(document).ready( function() {
       $("#create-db-link-form").css('display', 'none');
     });
 
+    // Add Index
+    $("#add-index-button").on("click", function() {
+      $("#add-index-form").css('display', 'block');
+    })
+    $("#add-index-close").on("click", function() {
+      $("#add-index-form").css('display', 'none');
+    });
+    $("#add-index-cancel").on("click", function() {
+      $("#add-index-form").css('display', 'none');
+    });
+    $("#add-index-save").on("click", function() {
+      $("#add-index-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
+
+    // Add encrypted attribute
+    $("#add-encrypted-attr-button").on("click", function() {
+      $("#add-encrypted-attr-form").css('display', 'block');
+    })
+    $("#add-encrypted-attr-close").on("click", function() {
+      $("#add-encrypted-attr-form").css('display', 'none');
+    });
+    $("#add-encrypted-attr-cancel").on("click", function() {
+      $("#add-encrypted-attr-form").css('display', 'none');
+    });
+    $("#add-encrypted-attr-save").on("click", function() {
+      $("#add-encrypted-attr-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
+
+    // Create Suffix
+    $("#add-suffix-close").on("click", function() {
+      $("#add-suffix-form").css('display', 'none');
+    });
+    $("#add-suffix-cancel").on("click", function() {
+      $("#add-suffix-form").css('display', 'none');
+    });
+    $("#add-suffix-save").on("click", function() {
+      $("#add-suffix-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
+
+    // Create Sub Suffix
+    $("#add-subsuffix-close").on("click", function() {
+      $("#add-subsuffix-form").css('display', 'none');
+    });
+    $("#add-subsuffix-cancel").on("click", function() {
+      $("#add-subsuffix-form").css('display', 'none');
+    });
+    $("#add-subsuffix-save").on("click", function() {
+      $("#add-subsuffix-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
+
+    // Init Suffix (import)
+    $("#import-ldif-close").on("click", function() {
+      $("#import-ldif-form").css('display', 'none');
+    });
+    $("#import-ldif-cancel").on("click", function() {
+      $("#import-ldif-form").css('display', 'none');
+    });
+    $("#import-ldif-save").on("click", function() {
+      $("#import-ldif-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
+
+    // Export Suffix (import)
+    $("#export-ldif-close").on("click", function() {
+      $("#export-ldif-form").css('display', 'none');
+    });
+    $("#export-ldif-cancel").on("click", function() {
+      $("#export-ldif-form").css('display', 'none');
+    });
+    $("#export-ldif-save").on("click", function() {
+      $("#export-ldif-form").css('display', 'none');
+      // Do the actual save in DS
+      // Update html
+    });
   });
 });
 
diff --git a/src/cockpit/389-console/js/ds.js b/src/cockpit/389-console/js/ds.js
index f7d33a68d..dcc3c5150 100644
--- a/src/cockpit/389-console/js/ds.js
+++ b/src/cockpit/389-console/js/ds.js
@@ -1,5 +1,22 @@
 var DS_HOME = "/etc/dirsrv/";
 var server_id = "None";
+var dn_regex = new RegExp( "^([A-Za-z]+=.*)" );
+
+
+
+// TODO validation functions
+
+function valid_dn (dn){
+  // Validate value is a valid DN (sanity validation)
+  var result = dn_regex.test(dn);
+  return result;
+}
+
+function valid_num (val){
+  // Validate value is a number
+  return !isNaN(val);
+}
+
 
 
 function search_dse(){
@@ -12,7 +29,14 @@ function search_dse(){
   );
 }
 
-function setup() {
+function sort_list (sel) {
+  var opts_list = sel.find('option');
+  opts_list.sort(function(a, b) { return $(a).text() > $(b).text() ? 1 : -1; });
+  sel.html('').append(opts_list);
+}
+
+function example() {
+  // Example test function
   $("#search").on("click", search_dse);
   //$("#getservers").on("click", get_insts);
 }
@@ -32,7 +56,7 @@ function get_insts() {
   var insts = [];
   var cmd = ["/bin/sh", "-c", "/usr/bin/ls -d " + DS_HOME + "slapd-*"];
 
-  console.log("Get instas");
+  console.log("Get insts");
   cockpit.spawn(cmd, { superuser: true }).done(function(data) {
     // Parse the output, and skip removed instances and empty lines
     var lines = data.split('\n');
@@ -43,6 +67,10 @@ function get_insts() {
       }
     }
 
+    if (server_id != "None") {
+      $("#ds-banner").html("Managing Instance <select class=\"btn btn-default dropdown ds-dropdown-server\" id=\"select-server\"></select>");
+    }
+
     // Populate the server instance drop down
     var select = document.getElementById("select-server");
     for(var i = 0; i < insts.length; i++) {
@@ -59,30 +87,25 @@ function get_insts() {
     } else {
       server_id = insts[0];
     }
-    if (server_id != "None") {
-      $("#ds-banner").html("389 Directory Server Management<hr class=\"ds-logo-hr\"><font size=\"2\">Managing instance: <b>" + server_id + "</b></font>");
-    }
+
+    $("body").show();
   }).fail(function(error){
     set_no_insts();
+    $("body").show();
   });
 }
 
 $(function() {
   $('#select-server').change(function() {
     server_id = $(this).val();
-    $("#ds-banner").html("389 Directory Server Management<hr class=\"ds-logo-hr\"><font size=\"2\">Managing instance: <b>" + server_id + "</b></font>");
+    $("#ds-banner").html("Managing Instance <select class=\"btn btn-default dropdown ds-dropdown-server\" id=\"select-server\"></select>");
   });
 });
 
 $(window.document).ready(function() {
-  $("body").show();
 
   if(navigator.userAgent.toLowerCase().indexOf('firefoxf') > -1) {  
-    console.log("mark its firefox");
-
-     
-    $("select@@@").focus( function() {
-      console.log('doing it');      
+    $("select@@@").focus( function() {     
       this.style.setProperty( 'outline', 'none', 'important' );
       this.style.setProperty( 'color', 'rgba(0,0,0,0)', 'important' );
       this.style.setProperty( 'text-shadow', '0 0 0 #000', 'important' );
